/*  INF3105 - Structures de données et algorithmes
    UQAM | Faculté des sciences | Département d'informatique
    Lab13 -- http://cria2.uqam.ca/INF3105/lab13/
 */

#ifndef _DICTIONNAIRE_H_
#define _DICTIONNAIRE_H_

#include <cassert>
#include <iostream>

template<class K, class V>
class Dictionnaire {
 public:
  Dictionnaire(int capacite);
  Dictionnaire(const Dictionnaire<K, V>&);
  ~Dictionnaire();

  V& operator[](const K&);
  const V& operator[](const K&) const;

  long stats() const { return nbTentatives; }

 private:
  struct Casier {
    Casier();
    bool occupe;
    K cle;
    V valeur;
  };

  Casier* casiers;
  int nbCasiers;
  long nbTentatives;

  Dictionnaire& operator=(const Dictionnaire&) const;
};

template<class K, class V>
Dictionnaire<K, V>::Dictionnaire(int capacite)
    : nbCasiers(capacite), nbTentatives(0) {
  casiers = new Casier[nbCasiers];
}

template<class K, class V>
Dictionnaire<K, V>::~Dictionnaire() {
  delete[] casiers;
}

template<class K, class V>
Dictionnaire<K, V>::Casier::Casier() : occupe(false), valeur() {}

template<class K, class V>
V& Dictionnaire<K, V>::operator[](const K& k) {
  // À compléter...
  ++nbTentatives;  // À chaque tentative, faire ++nbTentatives;
  int c = k.hash() % nbCasiers;
  std::cout << "c=" << c << std::endl;
  return casiers[c].valeur;
}

// Vous n'en aurez pas besoin pour le lab14
template<class K, class V>
const V& Dictionnaire<K, V>::operator[](const K&) const {
  assert(false);
}

#endif
